(define (bst/insert val tree) 
  ; Space: Theta(1) ... Theta(log n) ... Theta(n)
  ; Time:  Theta(1) ... Theta(log n) ... Theta(n)

  ; note: we aren't checking to make sure it's a binary *search* tree
  ;       just to keep the discussion simpler.  
  (check-binary-tree tree)
  (if (empty-binary-tree? tree) 
      (make-node val *empty-binary-tree* *empty-binary-tree*)
      (let ((curr-val (node-value tree))
            (left     (left-subtree tree))
            (right    (right-subtree tree)))
        (if (< val (node-value tree))
            (make-node curr-val
                       (bst/insert val left)
                       right)
            (make-node curr-val
                       left
                       (bst/insert val right))))))