(load "helpers.scm")(load "bst-def.scm")
(load "primitive-mutators.scm")
(load "fold.scm")
(load "list-bst.scm")
(load "bst-insert!.scm")

(define (binary-tree->list0 tree) 
  ; compact recursive version
  (binary-tree/fold (lambda (x l r) (set! counter (+ counter (length l))) (append! l (list x) r))
                    '()
                    tree))

(define counter 0)

(define (binary-tree->list tree)
  ; efficient version
  ; Space: Theta(n)
  ; Time:  Theta(n)
  (define (iter tail node)
    (check-binary-tree node)
    (if (empty-binary-tree? node)
        tail
        (begin
    (set! counter (+ counter 1))
          (set! tail (iter tail (left-subtree node)))
          (set-cdr! tail (list (node-value node)))
          (iter (cdr tail) (right-subtree node)))))
  (let ((answer-handle (list '())))
    (iter answer-handle tree)
    (cdr answer-handle)))

(define lst '(1 23 4 1 582 93 4 82 5 59 601  38 2 34 5 2 6 6 1 5 6 7 2 83 94 10 3295 1 3 50 39 6 4 2 1 6 7 7 2 4 7 87 2 43 3 6 9 10 3 5 12 6 1 6 7 7 283 3))
(define lst (append lst lst))(define lst (append lst lst))(define lst (append lst lst))(define lst (append lst lst))(define lst (append lst lst))(define lst (append lst lst))
(define lst (append lst lst))
(define bst (list->bst lst))

(time (begin (set! counter 0) (binary-tree->list0 bst) counter))

(time (begin (set! counter 0) (binary-tree->list bst) counter))